{ Copyright (c) 2000 by Mandys Tomas - Mandy Soft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit Ibbrowfr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, ExtCtrls,
  Menus, Buttons, DBCtrls, IBDatabase, Db, ComCtrls;

type
  TIBBrowserForm = class(TForm)
    PopupMenu1: TPopupMenu;
    Opentable1: TMenuItem;
    OpenDialog: TOpenDialog;
    Newtable1: TMenuItem;
    About1: TMenuItem;
    N4: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    TableListBox: TListBox;
    Panel5: TPanel;
    ShowSystemTables: TCheckBox;
    PageControl1: TPageControl;
    IBDatabase: TIBDatabase;
    IBTransaction: TIBTransaction;
    Opentable2: TMenuItem;
    Opennewtable1: TMenuItem;
    N1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Opentable1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure IBDatabaseAfterConnect(Sender: TObject);
    procedure IBDatabaseAfterDisconnect(Sender: TObject);
    procedure Newtable1Click(Sender: TObject);
    procedure ShowSystemTablesClick(Sender: TObject);
    procedure Opentable2Click(Sender: TObject);
    procedure TableListBoxDblClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FSaveCaption: string;
  public
    Settings: TStrings;
    DBReadOnly: Boolean;
    StopFlag: Boolean;
  end;

var
  IBBrowserForm: TIBBrowserForm;

resourcestring
  sAbout = 'Interbase browser v.1.11'#13#10'Copyright (c) 2000,2001,2002 by MandySoft'#13#10'tomas.mandys@2p.cz';
implementation
uses
  AuxStr, IBDM, CmdLine, IBFrame;

{$R *.DFM}

procedure TIBBrowserForm.FormCreate(Sender: TObject);
var
  S, S2: string;
  I, J: Integer;
begin
  FSaveCaption:= Caption;
  Settings:= TStringList.Create;
  IBDatabase.Close;
  IBDatabaseAfterDisconnect(nil);
  S:= '';
  GetCmdString('', clUpCase, S);
  IBDatabase.DatabaseName:= S;
  OpenDialog.FileName:= S;
  S:= '';
  GetCmdString('p:', clCaseSensitive, S);
  I:= 1;
  while I < Length(S) do
  begin
    S2:= ExtractFieldName(S, I);
    if (S2 <> '') and (Pos('=', S2) <> 0) then
    begin
      J:= Pos('=', S2);
      IBDatabase.Params.Values[Copy(S2, 1, J-1)]:= Copy(S2, J+1, Length(S2)); 
    end;
  end;
  IBDatabase.LoginPrompt:= IBDatabase.Params.Values['password'] = '';
  if IBDatabase.DatabaseName <> '' then
  begin
    IBDatabase.Open;
  end;
  DBReadOnly:= IsThereCmd('RO', clUpCase);
end;

procedure TIBBrowserForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Escape) and (Shift = []) then
    StopFlag:= True;
end;

procedure TIBBrowserForm.IBDatabaseAfterConnect(Sender: TObject);
begin
  IBDatabase.GetTableNames(TableListBox.Items, ShowSystemTables.Checked);
  Caption:= Format(FSaveCaption, [IBDatabase.DatabaseName]);
end;

procedure TIBBrowserForm.IBDatabaseAfterDisconnect(Sender: TObject);
begin
  TableListBox.Items.Clear;
  Caption:= Format(FSaveCaption, ['(none)']);
end;

procedure TIBBrowserForm.Newtable1Click(Sender: TObject);
var
  S: string;
begin
  if not OpenDialog.Execute then
    Exit;
  S:= ParamStr(0) + ' '+OpenDialog.Filename;
  if ofReadOnly in OpenDialog.Options then
    S:= S+' /RO';
  S:= S+#0;
  WinExec(@S[1], SW_SHOW);
end;

procedure TIBBrowserForm.Opentable1Click(Sender: TObject);
begin
  if not OpenDialog.Execute then
    Exit;
//  RO:= ofReadOnly in OpenDialog.Options;
  IBDatabase.Close;
  IBDatabase.DatabaseName:= OpenDialog.Filename;
  IBDatabase.Open;
end;


procedure TIBBrowserForm.ShowSystemTablesClick(Sender: TObject);
begin
  TableListBox.Items.Clear;
  IBDatabase.GetTableNames(TableListBox.Items, ShowSystemTables.Checked);
end;

procedure TIBBrowserForm.Opentable2Click(Sender: TObject);
var
  TS: TTabSheet;
  Fr: TFrame1;
  I: Integer;
  S: string;
begin
  if TableListBox.ItemIndex = -1 then
    Exit;
  S:= TableListBox.Items[TableListBox.ItemIndex];
  if (PageControl1.ActivePage = nil) or (Sender <> nil) and ((Sender as TComponent).Tag = 1) then
  begin
    TS:= TTabSheet.Create(Self);
    TS.PageControl:= PageControl1;
    PageControl1.ActivePage:= TS;
    Fr:= TFrame1.Create(Self);
    Fr.Name:= '';
    TS.InsertControl(Fr);
  end
  else
  begin
    Fr:= nil;
    for I:= 0 to PageControl1.PageCount-1 do
      if PageControl1.Pages[I].Caption = S then
      begin
        PageControl1.ActivePage:= PageControl1.Pages[I];
        Exit;
      end;
    for I:= 0 to PageControl1.ActivePage.ControlCount-1 do
      if PageControl1.ActivePage.Controls[I] is TFrame1 then
      begin
        Fr:= PageControl1.ActivePage.Controls[I] as TFrame1;
        Break;
      end;
  end;
  Fr.Table.Close;
  Fr.Table.TableName:= S;
  Fr.SetTableSettings;
  PageControl1.ActivePage.Caption:= Fr.Table.TableName;
  Fr.Table.ReadOnly:= DBReadOnly;
  Fr.Table.Open;
  PageControl1.Visible:= True;
end;

procedure TIBBrowserForm.TableListBoxDblClick(Sender: TObject);
begin
  Opentable2Click(nil);
end;

procedure TIBBrowserForm.About1Click(Sender: TObject);
begin
  MessageDlg(sAbout, mtInformation,  [mbOk], 0);
end;

procedure TIBBrowserForm.FormDestroy(Sender: TObject);
begin
  Settings.Free;
  inherited;
end;

end.

