{ Copyright (c) 2000 by Mandys Tomas - Mandy Soft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit ibframe;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, StdCtrls, Grids, DBGrids, ExtCtrls, Db, IBCustomDataSet, IBTable,
  Menus, IBUpdateSQL, IBQuery, IBSQL, Buttons, IBDatabase;

type
  TFrame1 = class(TFrame)
    Table: TIBTable;
    Panel1: TPanel;
    Panel3: TPanel;
    Splitter2: TSplitter;
    DBGrid: TDBGrid;
    DBMemo1: TDBMemo;
    Panel4: TPanel;
    IndexComboBox: TComboBox;
    Edit1: TEdit;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    PopupMenu1: TPopupMenu;
    Newtable1: TMenuItem;
    N4: TMenuItem;
    Search1: TMenuItem;
    N1: TMenuItem;
    Memoonoff1: TMenuItem;
    Countfield1: TMenuItem;
    Fillfieldinrecords1: TMenuItem;
    FieldsSubMenu: TMenuItem;
    FindDialog: TFindDialog;
    IBUpdateSQL1: TIBUpdateSQL;
    SearchField: TLabel;
    IBTransaction1: TIBTransaction;
    ExporttoCSV1: TMenuItem;
    SaveCSVDialog: TSaveDialog;
    ExportTABdelimited1: TMenuItem;
    procedure TableAfterOpen(DataSet: TDataSet);
    procedure IndexComboBoxChange(Sender: TObject);
    procedure Memoonoff1Click(Sender: TObject);
    procedure DBGridColEnter(Sender: TObject);
    procedure FieldsSubMenuClick(Sender: TObject);
    procedure Countfield1Click(Sender: TObject);
    procedure Fillfieldinrecords1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Search1Click(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure TableAfterClose(DataSet: TDataSet);
    procedure Newtable1Click(Sender: TObject);
    procedure TableNewRecord(DataSet: TDataSet);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure DBGridTitleClick(Column: TColumn);
    procedure DBGridDblClick(Sender: TObject);
    procedure DBGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DBGridColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure ExporttoCSV1Click(Sender: TObject);
  private
    Found: Boolean;
    FindFlag: Byte;
    DoubleClickedColumn: TColumn;
    GridFlag: Byte;
    procedure SetRO(En: Boolean);
    function IsIndexedColumn(Column: TColumn): Boolean;
    function ReadSett(const aName, Def: string): string;
    procedure RefreshTitles;
    function IsCurIndexedColumn(Column: TColumn): Boolean;
  public
    procedure GetTableSettings;
    procedure SetTableSettings;
    procedure SetGridSettings;
    procedure GetGridSettings;
  end;

resourcestring
  sInput = 'Input';
  scfMask = 'Counting mask (mask with one %d parameter)';
  scfStart = 'Start number';
  scfInc = 'Increment';
  scfCount = 'Count (-1..infinity)';
  sfrString = 'String';
implementation
uses
  ibbrowfr, AuxStr, Math;

{$R *.DFM}

procedure TFrame1.TableAfterOpen(DataSet: TDataSet);
const
  But= [nbEdit, nbPost, nbCancel];
  MaxWidth = 35;
var
  I, J: Integer;
  MI: TMenuItem;
  S1, S2: string;
  F: TField;
begin
  inherited;
  RefreshTitles;
  if Table.ReadOnly then DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons-But
                    else DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons+But;
  DBNavigator1.Width:= 10; { adjust width }
  for I:= 0 to Table.FieldCount-1 do
    if Table.Fields[I].DisplayWidth > MaxWidth then
      Table.Fields[I].DisplayWidth:= MaxWidth;
  while FieldsSubMenu.Count > 0 do
    FieldsSubMenu.Delete(0);
  for I:= 0 to Table.FieldCount-1 do
  begin
    MI:= TMenuItem.Create(Self);
    MI.Caption:= Table.Fields[I].FieldName;
    MI.Checked:= Table.Fields[I].Visible;
    MI.OnClick:= FieldsSubMenuClick;
    FieldsSubMenu.Add(MI);
  end;
  FieldsSubMenu.Enabled:= Table.FieldCount <> 0;
  IndexComboBox.Items.Clear;
  Table.GetIndexNames(IndexComboBox.Items);
  IndexComboBox.Items.Insert(0, '<no index>');
  IndexComboBox.ItemIndex:= 0;
  DBGridColEnter(nil);

  SetGridSettings;
  S1:= ''; S2:= '';
  for I:= 0 to Table.FieldCount-1 do
  begin
    Table.Fields[I].Required:= False;
  end;

  F:= Table.FindField(SearchField.Caption);
  if (F <> nil) and F.Visible then
  else
    begin
      J:= Table.FieldCount;
      SearchField.Caption:= '';
      for I:= 0 to Table.FieldCount-1 do
        if Table.Fields[I].Visible then
          J:= Min(Table.Fields[I].Index, J);
      if J < Table.FieldCount then
        SearchField.Caption:= Table.Fields[J].FieldName;
    end;
end;

procedure TFrame1.IndexComboBoxChange(Sender: TObject);
begin
  with IndexComboBox do
    if Text[1] = '<' then Table.IndexName:= ''
                     else Table.IndexName:= Text;
end;

procedure TFrame1.Memoonoff1Click(Sender: TObject);
begin
  if DBMemo1.Visible then
    Splitter2.Visible:= False;
  DBMemo1.Visible:= not DBMemo1.Visible;
  if DBMemo1.Visible then
    Splitter2.Visible:= True;
  DBMemo1.AutoDisplay:= DBMemo1.Visible;
end;

procedure TFrame1.DBGridColEnter(Sender: TObject);
begin
  if DBGrid.SelectedField = nil then DBMemo1.DataField:= ''
                                else DBMemo1.DataField:= DBGrid.SelectedField.FieldName;
end;

procedure TFrame1.FieldsSubMenuClick(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked:= not Checked;
    Table.FieldByName(StripHotKey(Caption)).Visible:= Checked;
  end;
end;

procedure TFrame1.Countfield1Click(Sender: TObject);
var
  aStart, aInc, aCount: Integer;
  S, aMask: string;
begin
  aMask:= '%d';
  if not InputQuery(sInput, scfMask, aMask) then
    Exit;
  S:= '1';
  if not InputQuery(sInput, scfStart, S) then
    Exit;
  aStart:= StrToInt(S);
  S:= '1';
  if not InputQuery(sInput, scfInc, S) then
    Exit;
  aInc:= StrToInt(S);
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

    IBBrowserForm.StopFlag:= False;
    while not Table.EOF and not IBBrowserForm.StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= Format(aMask, [aStart]);
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
      Inc(aStart, aInc);
    end;
end;

procedure TFrame1.Fillfieldinrecords1Click(Sender: TObject);
var
  aCount: Integer;
  S, aString: string;
begin
  aString:= '';
  if not InputQuery(sInput, sfrString, aString) then
    Exit;
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

  SetRO(True);
  try
    IBBrowserForm.StopFlag:= False;
    while not Table.EOF and not IBBrowserForm.StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= aString;
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
    end;
  finally
    SetRO(False);
  end;
end;

procedure TFrame1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Return) and (Shift = []) then
  begin
    if (Edit1.Text <> '') and (SearchField.Caption <> '') then
    begin
      if Table.FieldByName(SearchField.Caption).DataType in [ftDate, ftDateTime] then
        Table.Locate(SearchField.Caption, VarFromDateTime(StrToDateTime(Edit1.Text)), [loPartialKey])
      else
        Table.Locate(SearchField.Caption, Edit1.Text, [loCaseInsensitive, loPartialKey]);
      Key:= 0;
    end;
  end;
end;

procedure TFrame1.Search1Click(Sender: TObject);
begin
  Found:= False;
  FindDialog.Execute;
end;

procedure TFrame1.FindDialogFind(Sender: TObject);
var
  S, S2: string;
  F, F1, F2: Boolean;
  DownS: Boolean;
  function UpC(const S: string): string;
  begin
    Result:= S;
    if not (frMatchCase in FindDialog.Options) then
//      Result:= DBAnsiUpper(Table, Result);
      Result:= AnsiUpperCase(Result);
  end;
  procedure Mov;
  begin
    if DownS then Table.Next
             else Table.Prior;
  end;
begin
  if FindFlag <> 0 then
  begin
    IBBrowserForm.StopFlag:= True;
    Exit;
  end;
  IBBrowserForm.StopFlag:= False;
  Inc(FindFlag);
  try
    S:= Trim(UpC(FindDialog.FindText));
    DownS:= frDown in FindDialog.Options;

    if (Length(S) > 1) and (S[1] = '"') and (S[Length(S)] = '"') then
    begin
      Delete(S, 1, 1);
      Delete(S, Length(S), 1);
      F1:= False;
      F2:= False;
    end
  else
    begin
      F1:= S[1] = '*';
      if F1 then Delete(S, 1, 1);
      F2:= S[Length(S)] = '*';
      if F2 then Delete(S, Length(S), 1);
    end;
    if Found then
      Mov;
    repeat
      S2:= UpC(DBGrid.SelectedField.AsString);
      Application.ProcessMessages;
      if not F1 and not F2 then F:= S = S2 else
      if F1 and F2 then F:= Pos(S, S2) > 0 else
      if F2 then F:= S = Copy(S2, 1, Length(S)) else
      if F1 then F:= S = RStr(S2, Length(S));
      Found:= F;
      if F or IBBrowserForm.StopFlag or (DownS and Table.EOF) or (not DownS and Table.BOF) then Break;
      Mov;
    until False;
  finally
    Dec(FindFlag);
  end;
end;


procedure TFrame1.SetRO(En: Boolean);
begin
  DBGrid.Enabled:= not En;
  DBMemo1.Enabled:= not En;
end;

procedure TFrame1.TableAfterClose(DataSet: TDataSet);
begin
  DBGridColEnter(nil);
end;

procedure TFrame1.Newtable1Click(Sender: TObject);
var
  P: TControl;
begin
  Table.Close;
  P:= Parent;
  Parent:= nil;
  P.Free;
  if IBBrowserForm.PageControl1.PageCount = 0 then
    IBBrowserForm.PageControl1.Visible:= False;
end;

procedure TFrame1.TableNewRecord(DataSet: TDataSet);
var
  F: TField;
  S: string;
  IBSQL: TIBSQL;
begin
  IBSQL:= TIBSQL.Create(nil);
  try
    IBSQL.Database:= Table.Database;
    IBSQL.Transaction:= Table.Transaction;
    IBSQL.SQL.Add(Format('SELECT R.RDB$FIELD_NAME,R.RDB$DEFAULT_SOURCE,R.RDB$FIELD_SOURCE,F.RDB$DEFAULT_SOURCE AS DEF2 FROM RDB$RELATION_FIELDS R LEFT JOIN RDB$FIELDS F ON R.RDB$FIELD_SOURCE=F.RDB$FIELD_NAME WHERE R.RDB$RELATION_NAME=''%s'' ORDER BY R.RDB$FIELD_POSITION', [UpString(Table.TableName)]));
    IBSQL.ExecQuery;
    while not IBSQL.EOF do
    begin
      F:= DataSet.FindField(Trim(IBSQL.Fields[0].asString));
      if F <> nil then
      begin
        S:= Trim(IBSQL.Fields[1].asString);
        if S = '' then
          S:= Trim(IBSQL.Fields[3].asString);
        if Pos('DEFAULT ', S) = 1 then
        begin
          Delete(S, 1, Length('DEFAULT '));
          if (Length(S)>=2) and (S[1]='''') and (S[Length(S)]='''') then
          begin
            S:= Copy(S, 2, Length(S)-2);
            if S = 'NOW' then
              F.asDateTime:= Now()
            else
              F.asString:= S;
          end
          else if (S <> '') and (S[1] in ['0'..'9']) then
            F.asString:= S;
        end;
      end;
      IBSQL.Next;
    end;
  finally
    IBSQL.Free;
  end;
end;

procedure TFrame1.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
var
  B: TBookmark;
begin
  if Button = nbRefresh then
  begin
    Table.CheckBrowseMode;
    B:= Table.GetBookmark;
    try
      if Table.Transaction.InTransaction then
        Table.Transaction.Commit;
      Table.Transaction.StartTransaction;
      Table.Open;
      Table.GotoBookmark(B);
    finally
      Table.FreeBookmark(B);
    end;
    Abort;
  end;
end;

procedure TFrame1.DBGridTitleClick(Column: TColumn);
begin
  inherited;
  DoubleClickedColumn:= Column;
  if Column.Field <> nil then
    begin
      SearchField.Caption:= Column.Field.FieldName;
      GetTableSettings;
    end
  else
    SearchField.Caption:= '';
end;

procedure TFrame1.DBGridDblClick(Sender: TObject);
begin
  if DoubleClickedColumn <> nil then
    begin
      if IsIndexedColumn(DoubleClickedColumn) then
        begin
          DoubleClickedColumn.Index:= 0;
          if Table.IndexFieldNames <> DoubleClickedColumn.Field.FieldName then
          begin
            Table.IndexFieldNames:= DoubleClickedColumn.Field.FieldName;
            Table.Close;
            Table.Open;
            GetTableSettings;
            GetGridSettings;
            RefreshTitles;
          end;
        end;
      DoubleClickedColumn:= nil;
    end;
end;

type
  TDBGrid2 = class(TDBGrid)
  public
    property GridState: TGridState read FGridState;
  end;

procedure TFrame1.DBGridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DoubleClickedColumn:= nil;
  if TDBGrid2(Sender).FGridState = gsColSizing then
    GetGridSettings;
  inherited;
end;

procedure TFrame1.GetGridSettings;
var
  I: Integer;
begin
  for I:= 0 to DBGrid.Columns.Count-1 do
  begin
    IBBrowserForm.Settings.Values[Format('%s.%s.Width', [Table.TableName, DBGrid.Columns[I].FieldName])]:= IntToStr(DBGrid.Columns[I].Width);
    IBBrowserForm.Settings.Values[Format('%s.%s.Index', [Table.TableName, DBGrid.Columns[I].FieldName])]:= IntToStr(I);
  end;
end;

procedure TFrame1.GetTableSettings;
begin
  IBBrowserForm.Settings.Values[Format('%s.Index', [Table.TableName])]:= Table.IndexFieldNames;
  IBBrowserForm.Settings.Values[Format('%s.SearchField', [Table.TableName])]:= SearchField.Caption;
end;

function TFrame1.IsIndexedColumn(Column: TColumn): Boolean;
begin
  Result:= False;
  if Column.Field=nil then
    Exit;
  Result:= True;  // all could be indexed
end;

procedure TFrame1.SetGridSettings;
var
  St: TStrings;
  I, J, N: Integer;
begin
  Inc(GridFlag);
  try
    St:= TStringList.Create;
    try
      for I:= 0 to DBGrid.Columns.Count-1 do
      begin
        St.AddObject(DBGrid.Columns[I].FieldName, Pointer(StrToInt(ReadSett(Format('%s.%s.Index', [Table.TableName, DBGrid.Columns[I].FieldName]), IntToStr(I)))));
        try
          DBGrid.Columns[I].Width:= StrToInt(ReadSett(Format('%s.%s.Width', [Table.TableName, DBGrid.Columns[I].FieldName]), IntToStr(DBGrid.Columns[I].Width)));
        except
        end;
      end;
      N:= 0;
      while N < DBGrid.Columns.Count-1 do
      begin
        for J:= 0 to DBGrid.Columns.Count-1 do
        begin
          if Pointer(N) = St.Objects[J] then
          begin
            for I:= 0 to DBGrid.Columns.Count-1 do
              if DBGrid.Columns[I].FieldName = St[J] then
              begin
                DBGrid.Columns[I].Index:= N;
                Break;
              end;
          end;
        end;
        Inc(N);
      end;
    finally
      St.Free;
    end;
  finally
    Dec(GridFlag);
  end;
end;

procedure TFrame1.SetTableSettings;
begin
  Table.IndexFieldNames:= ReadSett(Format('%s.Index', [Table.TableName]), Table.IndexFieldNames);
  SearchField.Caption:= ReadSett(Format('%s.SearchField', [Table.TableName]), SearchField.Caption);
end;

function TFrame1.ReadSett(const aName, Def: string): string;
begin
  Result:= IBBrowserForm.Settings.Values[aName];
  if Result = '' then
    Result:= Def;
end;

procedure TFrame1.DBGridColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
  inherited;
  if GridFlag = 0 then
    GetGridSettings;
end;

procedure TFrame1.RefreshTitles;
var
  I: Integer;
begin
  for I:= 0 to DBGrid.Columns.Count-1 do
    with DBGrid.Columns[I] do
    begin
      if IsCurIndexedColumn(DBGrid.Columns[I]) then
        Title.Font.Color:= clRed else
      if IsIndexedColumn(DBGrid.Columns[I]) then
        Title.Font.Color:= clBlue else
        Title.Font.Color:= clWindowText;
    end;
end;

function TFrame1.IsCurIndexedColumn(Column: TColumn): Boolean;
begin
  Result:= False;
  if Column.Field = nil then
    Exit;
  Result:= Column.Field.FieldName = Table.IndexFieldNames;
end;

procedure TFrame1.ExporttoCSV1Click(Sender: TObject);
var
  St: TStream;
  S: string;
  I: Integer;
  Delim: Char;
const
  CRLF = #13#10;
begin
  if SaveCSVDialog.Execute then
  begin
    case (Sender as TComponent).Tag of
      1: Delim:= #9;
    else
     {2: }Delim:= ';';
    end;
    St:= TFileStream.Create(SaveCSVDialog.FileName, fmCreate);
    try
      S:= '';
      for I:= 0 to Table.FieldCount-1 do
        if Table.Fields[I].Visible then
        begin
          if S <> '' then
            S:= S+Delim;
          S:= S+Table.Fields[I].FieldName;
        end;
      S:= S+CRLF;
      St.Write(S[1], Length(S));
      Table.First;
      while not Table.EOF do
      begin
        S:= '';
        for I:= 0 to Table.FieldCount-1 do
          if Table.Fields[I].Visible then
          begin
            if S <> '' then
              S:= S+Delim;
            S:= S+Table.Fields[I].asString;
          end;
        S:= S+CRLF;
        St.Write(S[1], Length(S));
        Table.Next;
      end;
    finally
      St.Free;
    end;
  end;
end;

end.
